<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: common.php 375 2004-06-14 13:24:39Z scott $
*/

    include_once 'db.php';
    
    function MAX_checkAd($advertiserId, $placementId, $adId)
    {
        $allowed = false;
        if (is_numeric($advertiserId) && is_numeric($placementId) && is_numeric($adId)) {
            if (phpAds_isUser(phpAds_Admin)) {
                $allowed = (sizeof(MAX_getEntities('ad', array('advertiser_id' => $advertiserId, 'placement_id' => $placementId, 'ad_id' => $adId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $allowed = (sizeof(MAX_getEntities('ad', array('agency_id' => phpAds_getAgencyID(), 'advertiser_id' => $advertiserId, 'placement_id' => $placementId, 'ad_id' => $adId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Client)) {
                $allowed = (advertiserId == phpAds_getUserID()) && (sizeof(MAX_getEntities('ad', array('advertiser_id' => $advertiserId, 'placement_id' => $placementId, 'ad_id' => $adId), false)) > 0);
            }
        }
        return $allowed;
    }
    
    function MAX_checkAdvertiser($advertiserId)
    {
        $allowed = false;
        if (is_numeric($advertiserId)) {
            if (phpAds_isUser(phpAds_Admin)) {
                $allowed = (sizeof(MAX_getEntities('advertiser', array('advertiser_id' => $advertiserId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $allowed = (sizeof(MAX_getEntities('advertiser', array('agency_id' => phpAds_getAgencyID(), 'advertiser_id' => $advertiserId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Client)) {
                $allowed = ($advertiserId == phpAds_getUserID()) && (sizeof(MAX_getEntities('advertiser', array('advertiser_id' => $advertiserId), false)) > 0);
            }
        }
        return $allowed;
    }
    
    function MAX_checkAgency($agencyId)
    {
        $allowed = false;
        if (is_numeric($agencyId)) {
            if (phpAds_isUser(phpAds_Admin)) {
                $allowed = (sizeof(MAX_getEntities('agency', array('agency_id' => $agencyId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $allowed = ($agencyId == phpAds_getUserId()) && (sizeof(MAX_getEntities('agency', array('agency_id' => $agencyId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Client)) {
                $allowed = ($agencyId == phpAds_getAgencyID()) && (sizeof(MAX_getEntities('agency', array('agency_id' => $agencyId), false)) > 0);
            }
        }
        return $allowed;
    }
    
    function MAX_checkPlacement($advertiserId, $placementId)
    {
        $allowed = false;
        if (is_numeric($advertiserId) && is_numeric($placementId)) {
            if (phpAds_isUser(phpAds_Admin)) {
                $allowed = (sizeof(MAX_getEntities('placement', array('advertiser_id' => $advertiserId, 'placement_id' => $placementId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $allowed = (sizeof(MAX_getEntities('placement', array('agency_id' => phpAds_getAgencyID(), 'advertiser_id' => $advertiserId, 'placement_id' => $placementId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Client)) {
                $allowed = (advertiserId == phpAds_getUserID()) && (sizeof(MAX_getEntities('placement', array('advertiser_id' => $advertiserId, 'placement_id' => $placementId), false)) > 0);
            }
        }
        return $allowed;
    }
    
    function MAX_checkPublisher($publisherId)
    {
        $allowed = false;
        if (is_numeric($publisherId)) {
            if (phpAds_isUser(phpAds_Admin)) {
                $allowed = (sizeof(MAX_getEntities('publisher', array('publisher_id' => $publisherId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $allowed = (sizeof(MAX_getEntities('publisher', array('agency_id' => phpAds_getAgencyID(), 'publisher_id' => $publisherId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Affiliate)) {
                $allowed = ($publisherId == phpAds_getUserID()) && (sizeof(MAX_getEntities('publisher', array('publisher_id' => $publisherId), false)) > 0);
            }
        }
        return $allowed;
    }
    
    function MAX_checkTracker($advertiserId, $trackerId)
    {
        $allowed = false;
        if (is_numeric($advertiserId) && is_numeric($trackerId)) {
            if (phpAds_isUser(phpAds_Admin)) {
                $allowed = (sizeof(MAX_getEntities('tracker', array('advertiser_id' => $advertiserId, 'tracker_id' => $trackerId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $allowed = (sizeof(MAX_getEntities('tracker', array('agency_id' => phpAds_getAgencyID(), 'advertiser_id' => $advertiserId, 'tracker_id' => $trackerId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Client)) {
                $allowed = (advertiserId == phpAds_getUserID()) && (sizeof(MAX_getEntities('tracker', array('advertiser_id' => $advertiserId, 'tracker_id' => $trackerId), false)) > 0);
            }
        }
        return $allowed;
    }
    
    function MAX_checkZone($publisherId, $zoneId)
    {
        $allowed = false;
        if (is_numeric($publisherId) && is_numeric($zoneId)) {
            if (phpAds_isUser(phpAds_Admin)) {
                $allowed = (sizeof(MAX_getEntities('zone', array('publisher_id' => $publisherId, 'zone_id' => $zoneId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $allowed = (sizeof(MAX_getEntities('zone', array('agency_id' => phpAds_getAgencyID(), 'publisher_id' => $publisherId, 'zone_id' => $zoneId), false)) > 0);
            } elseif (phpAds_isUser(phpAds_Affiliate)) {
                $allowed = ($publisherId == phpAds_getUserID()) && (sizeof(MAX_getEntities('zone', array('publisher_id' => $publisherId, 'zone_id' => $zoneId), false)) > 0);
            }
        }
        return $allowed;
    }
    
    function MAX_isExpanded($id, $expand, &$aNodes, $prefix)
    {
        $isExpanded = false;
        if ($expand == 'all') {
            $isExpanded = true;
            if (!in_array($prefix . $id, $aNodes)) {
                $aNodes[] = $prefix . $id;
            }
        } elseif ($expand != 'none' && in_array($prefix . $id, $aNodes)) {
                $isExpanded = true;
        }
        
        return $isExpanded;
    }
    
    function MAX_getValue($key, $default = null)
    {
        $value = $default;
        if (isset($_REQUEST[$key])) {
            $value = $_REQUEST[$key];
            if (!get_magic_quotes_gpc()) MAX_addslashes($value);
        }
        
        return $value;
    }
    
    function MAX_getStoredValue($key, $default)
    {
        global $Session;
        $pageName = basename($_SERVER['PHP_SELF']);

        $value = $default;
        if (isset($_REQUEST[$key])) {
            $value = $_REQUEST[$key];
            if (!get_magic_quotes_gpc()) MAX_addslashes($value);
        } elseif (isset($Session['prefs'][$pageName][$key])) {
            $value = $Session['prefs'][$pageName][$key];
        }
        
        return $value;
    }
    
    function MAX_addslashes(&$item)
    {
        if (isset($item)) {
            if (is_array($item)) {
                array_walk($item, 'MAX_addslashes');
            } else {
                $item = addslashes($item);
            }
        }
    }
    
	function MAX_arrayMergeRecursive(&$a, &$b)
	{
	    $keys = array_keys($a);
	    foreach($keys as $key) {
	        if(isset($b[$key])) {
	            if(is_array($a[$key]) and is_array($b[$key])) {
	                merge($a[$key],$b[$key]);
	            } else {
	                $a[$key] = $b[$key];
	            }
	        }
	    }
	    $keys = array_keys($b);
	    foreach($keys as $key) {
	        if(!isset($a[$key])) {
	            $a[$key] = $b[$key];
	        }
	    }
	}
	
    function MAX_getStoredArray($key, $default)
    {
        global $Session;
        $pageName = basename($_SERVER['PHP_SELF']);
        
        $value = $default;
        if (isset($_REQUEST[$key])) {
            $value = explode(',',$_REQUEST[$key]);
            if (!get_magic_quotes_gpc()) MAX_addslashes($value);
        } elseif (isset($Session['prefs'][$pageName][$key])) {
            $value = explode(',',$Session['prefs'][$pageName][$key]);
        }
        
        return $value;
    }
    
    function MAX_adjustNodes(&$aNodes, $expand, $collapse)
    {
        if (!empty($expand)) {
            if ($expand != 'all') {
                if ($expand == 'none') {
                    $aNodes = array();
                }
                elseif (!in_array($expand, $aNodes)) {
                    $aNodes[] = $expand;
                }
            }
        }
        
        if (!empty($collapse) && in_array($collapse, $aNodes) ) {
            unset($aNodes[array_search($collapse, $aNodes)]);
        }
    }
    
    function MAX_getBannerName($description, $alt)
    {
        global $strUntitled;
        
        $name = $strUntitled;
        if (!empty($alt)) $name = $alt;
        if (!empty($description)) $name = $description;                        
        $name = phpAds_breakString ($name, '30');
        
        return $name;
    }
    
    function MAX_addDefaultPlacementZones($adId, $placementId)
    {
        $aAdZones = MAX_getEntities('ad_zone_assoc', array('ad_id' => $adId), true, 'zone_id');
        $aPlacementZones = MAX_getEntities('placement_zone_assoc', array('placement_id' => $placementId), true, 'zone_id');
        if (!empty($aPlacementZones)) {
            foreach ($aPlacementZones as $zoneId => $aPlacementZone) {
                if (!isset($aAdZones[$zoneId])) {
                    MAX_addEntity('ad_zone_assoc', array('ad_id' => $adId, 'zone_id' => $zoneId));
                }
            }
        }
    }
    
    // For a given ad id, make sure that zones have correct size/type.  Otherwise, unlink ads from the zone...
    function MAX_adjustAdZones($adId)
    {
        $aAdZones = MAX_getEntities('ad_zone_assoc', array('ad_id' => $adId), true, 'zone_id');
        if (!empty($aAdZones)) {
            $aAd = MAX_getEntity('ad', $adId);
            $aZones = MAX_getEntities('zone', array('zone_id' => implode(',', array_keys($aAdZones))));
            foreach ($aZones as $zoneId => $aZone) {
                if (!MAX_checkAdZoneValid($aZone, $aAd)) {
                    MAX_removeEntities('ad_zone_assoc', array('zone_id' => $zoneId, 'ad_id' => $adId));
                }
            }
        }
    }
    
    function MAX_adjustZoneAds($zoneId)
    {
        $aAdZones = MAX_getEntities('ad_zone_assoc', array('zone_id' => $zoneId), true, 'ad_id');
        if (!empty($aAdZones)) {
            $aZone = MAX_getEntity('zone', $zoneId);
            $aAds = MAX_getEntities('ad', array('ad_id' => implode(',', array_keys($aAdZones))));
            foreach ($aAds as $adId => $aAd) {
                if (!MAX_checkAdZoneValid($aZone, $aAd)) {
                    MAX_removeEntities('ad_zone_assoc', array('zone_id' => $zoneId, 'ad_id' => $adId));
                }
            }
        }
    }
    
    function MAX_checkAdZoneValid($aZone, $aAd)
    {
        $valid = true;
        if ($aZone['width'] > -1 && $aZone['width'] != $aAd['width']) {
            $valid = false;
        } elseif ($aZone['height'] > -1 && $aZone['height'] != $aAd['height']) {
            $valid = false;
        } elseif ($aAd['type'] == 'txt' && $aZone['type'] != phpAds_ZoneText) {
            $valid = false;
        } elseif ($aZone['type'] == phpAds_ZoneText && $aAd['type'] != 'txt') {
            $valid = false;
        }
        return $valid;
    }
    
    function MAX_copyAd($adId)
    {
        $aAd = MAX_getEntity('ad', $adId);
        return _copyAd($aAd, true);
    }
    
    function _copyAdZone($aAdZone)
    {
        unset($aAdZone['zone_ad_id']);
        return MAX_addEntity('ad_zone_assoc', $aAdZone);
    }
    
    function MAX_copyPlacement($placementId)
    {
        $aPlacement = MAX_getEntity('placement', $placementId);
        return _copyPlacement($aPlacement, true);
    }
    
    function MAX_copyTracker($trackerId)
    {
        $aTracker = MAX_getEntity('tracker', $trackerId);
        return _copyTracker($aTracker, true);
    }
    
    function MAX_copyZone($zoneId)
    {
        $aZone = MAX_getEntity('zone', $zoneId);
        return _copyZone($aZone, true);
    }
    
    function _copyAd($aAd, $checkUniqueNames = false)
    {
        include_once '../admin/lib-storage.inc.php';
        
        // Copy the linked creative
        $newFile = phpAds_ImageDuplicate($aAd['type'], $aAd['filename']);
        if ($newFile !== false) {
            $aAd['filename'] = $newFile;
        }
        // Remove the existing advert id
        $adId = $aAd['ad_id'];
        unset($aAd['ad_id']);
        // Check for unique names
        if ($checkUniqueNames) {
            $aAds = MAX_getEntities('ad', array('placement_id' => $aAd['placement_id']), false);
            _getUniqueName($aAd, $aAds, $GLOBALS['strCopy']);
        }
        // Add the new ad
        $newAdId = MAX_addEntity('ad', $aAd);
        
        // Copy the limitations
        $aLimitations = MAX_getEntities('limitation', array('ad_id' => $adId));
        foreach($aLimitations as $aLimitation) {
            $aLimitation['ad_id'] = $newAdId;
            MAX_addEntity('limitation', $aLimitation);
        }
        
        // Copy the zone ad associations
        $aAdZones = MAX_getEntities('ad_zone_assoc', array('ad_id' => $adId));
        foreach($aAdZones as $aAdZone) {
            $aAdZone['ad_id'] = $newAdId;
            _copyAdZone($aAdZone);
        }
        
        return $newAdId;
    }
    
    function _copyPlacement($aPlacement, $checkUniqueNames = false)
    {
        $placementId = $aPlacement['placement_id'];
        unset($aPlacement['placement_id']);
        
        if ($checkUniqueNames) {
            $aPlacements = MAX_getEntities('placement', array('advertiser_id' => $aPlacement['advertiser_id']), false);
            _getUniqueName($aPlacement, $aPlacements, $GLOBALS['strCopy']);
        }
        MAX_addslashes($aPlacement);
        $newPlacementId = MAX_addEntity('placement', $aPlacement);
        
        $aPlacementTrackers = MAX_getEntities('placement_tracker', array('placement_id' => $placementId));
        foreach($aPlacementTrackers as $aPlacementTracker) {
            $aPlacementTracker['placement_id'] = $newPlacementId;
            _copyPlacementTracker($aPlacementTracker);
        }
        
        $aPlacementZones = MAX_getEntities('placement_zone_assoc', array('placement_id' => $placementId));
        foreach($aPlacementZones as $aPlacementZone) {
            $aPlacementZone['placement_id'] = $newPlacementId;
            _copyPlacementZone($aPlacementZone);
        }
        
        $aAds = MAX_getEntities('ad', array('placement_id' => $placementId));
        foreach($aAds as $aAd) {
            $aAd['placement_id'] = $newPlacementId;
            _copyAd($aAd, $aAds);
        }
        
        return $newPlacementId;
    }
    
    function _copyPlacementTracker($aPlacementTracker)
    {
        unset($aPlacementTracker['placement_tracker_id']);
        return MAX_addEntity('placement_tracker', $aPlacementTracker);
    }
    
    function _copyTracker($aTracker, $checkUniqueNames = false)
    {
        $trackerId = $aTracker['tracker_id'];
        unset($aTracker['tracker_id']);
        
        if ($checkUniqueNames) {
            $aTrackers = MAX_getEntities('tracker', array('advertiser_id' => $aTracker['advertiser_id']), false);
            _getUniqueName($aTracker, $aTrackers, $GLOBALS['strCopy']);
        }
        
        $newTrackerId = MAX_addEntity('tracker', $aTracker);
        
        $aPlacementTrackers = MAX_getEntities('placement_tracker', array('tracker_id' => $trackerId));
        foreach($aPlacementTrackers as $aPlacementTracker) {
            $aPlacementTracker['tracker_id'] = $newTrackerId;
            _copyPlacementTracker($aPlacementTracker);
        }
        
        $aVariables = MAX_getEntities('variable', array('tracker_id' => $trackerId));
        foreach($aVariables as $aVariable) {
            $aVariable['tracker_id'] = $newTrackerId;
            _copyVariable($aVariable);
        }
        
        return $newTrackerId;
    }
    
    function _copyVariable($aVariable)
    {
        unset($aVariable['variable_id']);
        return MAX_addEntity('variable', $aVariable);
    }
    
    function _copyPlacementZone($aPlacementZone)
    {
        unset($aPlacementZone['placement_zone_assoc_id']);
        return MAX_addEntity('placement_zone_assoc', $aPlacementZone);
    }
    
    function _copyZone($aZone, $checkUniqueNames = false)
    {
        $zoneId = $aZone['zone_id'];
        unset($aZone['zone_id']);
        
        if ($checkUniqueNames) {
            $aZones = MAX_getEntities('zone', array('publisher_id' => $aZone['publisher_id']), false);
            _getUniqueName($aZone, $aZones, $GLOBALS['strCopy']);
        }
        
        $newZoneId = MAX_addEntity('zone', $aZone);
        
        $aPlacementZones = MAX_getEntities('placement_zone_assoc', array('zone_id' => $zoneId));
        foreach($aPlacementZones as $aPlacementZone) {
            $aPlacementZone['zone_id'] = $newZoneId;
            _copyPlacementZone($aPlacementZone);
        }
        
        $aAdZones = MAX_getEntities('ad_zone_assoc', array('zone_id' => $zoneId));
        foreach($aAdZones as $aAdZone) {
            $aAdZone['zone_id'] = $newZoneId;
            _copyAdZone($aAdZone);
        }
        
        return $newZoneId;
    }
    
    function _getUniqueName(&$aEntity, $aOtherEntities, $str)
    {
        $same = false;
        $name = $aEntity['name'];
        foreach($aOtherEntities as $aOtherEntity) {
            if ($name == $aOtherEntity['name']) {
                $same = true;
                // Three cases:
                // a. 'joe' => 'joe (copy)'
                // b. 'joe (copy)' => 'joe (copy 2)'
                // c. 'joe (copy n)' => 'joe (copy n+1)'
                if (preg_match("/(.*)\($str (\d+)\)/", $name, $matches)) {
                    $n = $matches[2] + 1;
                    $name = "{$matches[1]}($str $n)";
                } elseif (preg_match("/(.*)\($str\)/", $name, $matches)) {
                    $name = "{$matches[1]}($str 2)";
                } else {
                    $name = "$name ($str)";
                }
                $aEntity['name'] = $name;
                break;
            }
        }
        if ($same)
            _getUniqueName($aEntity, $aOtherEntities, $str);
    }
    
    function MAX_removeFile($adId)
    {
        $aAd = MAX_getEntity('ad', $adId);
        _removeFile($aAd);
    }
    
    function MAX_removeFiles($aParams)
    {
        $aAds = MAX_getEntities('ad', $aParams);
        foreach ($aAds as $aAd) {
            _removeFile($aAd);
        }
    }
    
    function _removeFile($aAd)
    {
    	global $phpAds_config;
    	
        if (!empty($aAd['filename'])) {
            if ($aAd['type'] == 'web') {
                if ($phpAds_config['type_web_mode'] == 0) {
                    $fileName = "{$phpAds_config['type_web_dir']}/{$aAd['filename']}";
                    if (@file_exists($fileName)) {
                        @unlink ($fileName);
                    }
                } else {
                    // FTP mode
                    $server = parse_url($phpAds_config['type_web_ftp']);
                    if ($server['path'] != '' && substr($server['path'], 0, 1) == '/') {
                        $server['path'] = substr ($server['path'], 1);
                    }
                    if ($server['scheme'] == 'ftp') {
                        $conn_id = @ftp_connect($server['host']);
                        if ($server['pass'] && $server['user'])
                            $login = @ftp_login ($conn_id, $server['user'], $server['pass']);
                        else
                            $login = @ftp_login ($conn_id, 'anonymous', $phpAds_config['admin_email']);
                        if (($conn_id) || ($login)) {
                            if ($server['path'] != '')
                                @ftp_chdir ($conn_id, $server['path']);
                    		if (@ftp_size ($conn_id, $aAd['filename']) > 0) {
                                @ftp_delete ($conn_id, $aAd['filename']);
                            }
                            @ftp_quit($conn_id);
                        }
                    }
                }
            } elseif ($aAd['type'] == 'sql') {
                MAX_removeEntity('image', $aAd['filename']);
            }
        }
    }
    
    function MAX_addLinkedAdsToZone($zoneId, $placementId)
    {
        $aParams = MAX_getLinkedAdParams($zoneId);
        $aParams['placement_id'] = $placementId;
        
        $aAds = MAX_getEntities('ad', $aParams, false);
        $aLinkedAds = MAX_getEntities('ad_zone_assoc', array('zone_id' => $zoneId), false, 'ad_id');
        foreach ($aAds as $adId => $aAd) {
            if (!isset($aLinkedAds[$adId])) {
                MAX_addEntity('ad_zone_assoc', array('zone_id' => $zoneId, 'ad_id' => $adId));
            }
        }
    }
    
    // Get ad limitation parameters
    function MAX_getLinkedAdParams($zoneId)
    {
        $aParams = array();
        $aZone = MAX_getEntity('zone', $zoneId);
        if ($aZone['type'] == phpAds_ZoneText) {
            $aParams['ad_type'] = 'txt';
        } else {
            if ($aZone['width'] > -1) {
                $aParams['ad_width'] = $aZone['width'];
            }
            if ($aZone['height'] > -1) {
                $aParams['ad_height'] = $aZone['height'];
            }
        }
        
        return $aParams;
    }
?>
